<style>
    .ck-editor__editable {
        min-height: 300px;
    }
    .my-custom-class {
        background-color: rgb(204, 204, 204);
        max-height: 150px;
        overflow: auto;

    }
    .switch {
        position: relative;
        display: inline-block;
        width: 60px;
        height: 34px;
    }

    .switch input { 
        opacity: 0;
        width: 0;
        height: 0;
    }
    .slider {
        position: absolute;
        cursor: pointer;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background-color: #ccc;
        -webkit-transition: .4s;
        transition: .4s;
    }

    .slider:before {
        position: absolute;
        content: "";
        height: 26px;
        width: 26px;
        left: 4px;
        bottom: 4px;
        background-color: white;
        -webkit-transition: .4s;
        transition: .4s;
    }

    input:checked + .slider {
        background-color: #2196F3;
    }

    input:focus + .slider {
        box-shadow: 0 0 1px #2196F3;
    }

    input:checked + .slider:before {
        -webkit-transform: translateX(26px);
        -ms-transform: translateX(26px);
        transform: translateX(26px);
    }

    /* Rounded sliders */
    .slider.round {
        border-radius: 34px;
    }

    .slider.round:before {
        border-radius: 50%;
    }
    .toast {
        opacity: 1 !important;
    }
</style>

<template>
    <b-card no-body>
        <b-card-header class="border-0">
            <h3 class="mb-0">List Table</h3>
        </b-card-header>
        <b-card-header class="border-0">
            <b-button @click="edit()">Create Data</b-button>
        </b-card-header>

        <el-table class="table-responsive table" header-row-class-name="thead-light" :data="data">
            <el-table-column label="Article" min-width="300px" prop="article">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span class="font-weight-600 article mb-0 text-sm">{{row.article}}</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Author" min-width="300px" prop="author">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span class="font-weight-600 author mb-0 text-sm">{{row.author}}</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Category" min-width="200px" prop="category">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span v-if="row.category" class="font-weight-600 category mb-0 text-sm">{{row.category.name}}</span>
                            <span v-else class="font-weight-600 category mb-0 text-sm">-</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Headline" min-width="200px" prop="headline">
                <template v-slot="{row}">
                    <b-badge v-if="row.set_as_headline == 'Y'" variant="success" class="badge-lg">
                        <i class="bg-succes"></i>
                        YES
                    </b-badge>
                    <b-badge v-else variant="warning" class="badge-lg">
                        <i class="bg-warning"></i>
                        NO
                    </b-badge>
                </template>
            </el-table-column>

            <el-table-column label="Status" min-width="200px" prop="type">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <button v-if="row.status == 'publish'" class="btn btn-warning btn sm" disabled><i class="fas fa-lock-open"></i></button>
                            <button v-else class="btn btn-warning btn sm" disabled><i class="fas fa-lock"></i></button>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <!-- <el-table-column label="Created" min-width="200px" prop="created">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span class="font-weight-600 created mb-0 text-sm">{{row.created_at}}</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column> -->
            <el-table-column label="Action" min-width="200px" prop="action">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <div class="btn-group">
                                <button class="btn btn-sm btn-primary" id="show-btn" @click="edit(row.id)">Edit</button>
                                <button class="btn btn-sm btn-danger" id="show-btn" @click="delete_data(row.id)">Delete</button>
                            </div>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
        </el-table>


        <b-card-footer class="py-4 d-flex justify-content-end">
            <base-pagination v-model="currentPage" :per-page="10" :total="50"></base-pagination>
        </b-card-footer>

        <b-modal v-model="modalShow" size="lg" class="modal modal-fixed-footer" title="Category" @ok="save()">
            <b-card-body>
                <form @submit="save()" ref="form">
                    <!-- <base-input v-model="dataModal.id" /> -->
                    <!-- <input type="hidden" v-model="dataModal.id" > -->
                    <base-input label="Article" v-model="dataModal.article"  />

                    <base-input label="Author" v-model="dataModal.author"  />

                    <base-input label="Description">
                        <ckeditor :editor="editor" v-model="dataModal.description" :config="editorConfig" rows="10"></ckeditor>
                    </base-input>

                    <base-input label="Parent">
                        <select class="form-control" v-model="dataModal.category.id">
                            <option :value="null">-- Select --</option>
                            <option v-for="(item, index) in selectListCategory" :value="item.id" :key="index">{{item.name}}</option>
                        </select>     
                    </base-input>

                    <div class="row">
                        <div class="col-lg-6 col-sm-12 col-md-12">
                            <base-input label="Set as Headline">
                                <b-form-group>
                                    <b-form-radio class="custom-control-inline" v-model="dataModal.set_as_headline" value="Y">YES</b-form-radio>
                                    <b-form-radio class="custom-control-inline" v-model="dataModal.set_as_headline" value="N">NO</b-form-radio>
                                </b-form-group>
                            </base-input>
                        </div>
                        <div class="col-lg-6 col-sm-12 col-md-12">
                            <base-input label="Status">
                                <b-form-group>
                                    <b-form-radio class="custom-control-inline" v-model="dataModal.status" value="publish">Publish</b-form-radio>
                                    <b-form-radio class="custom-control-inline" v-model="dataModal.status" value="draft">Draft</b-form-radio>
                                </b-form-group>
                            </base-input>
                        </div>
                    </div>
                    <input-tag v-model="dataModal.article_tags"></input-tag>
                </form>
            </b-card-body>
        </b-modal>

    </b-card>
</template>


<script>
    import { Table, TableColumn} from 'element-ui'
    //Bootstrap and jQuery libraries
    import 'bootstrap/dist/css/bootstrap.min.css';
    import 'jquery/dist/jquery.min.js';
    //Datatable Modules
    import "datatables.net-dt/js/dataTables.dataTables"
    import "datatables.net-dt/css/jquery.dataTables.min.css"
    import $ from 'jquery';
    import ArticleService from '../../service/admin/ArticleService'
    import CategoryService from '../../service/admin/CategoryService'
    import ClassicEditor from '@ckeditor/ckeditor5-build-classic';

  export default {
    name: 'light-table',
    components: {
      [Table.name]: Table,
      [TableColumn.name]: TableColumn,
    },
    data() {
      return {
        data:[],
        dataModal:{
            id : '',
            article : '',
            description : '',
            status : '',
            author : '',
            category : '',
            set_as_headline : '',
            article_tags : [],
        },
        selectListCategory: [],
        modalShow: false,
        title: '',
        show: false,
        editor: ClassicEditor,
        editorConfig: {
            // The configuration of the editor.
        },
        currentPage: 1

      };
    },
    computed: {
        // hasCategory(){
        //     let ret = []
        //     if (this.list_category) {
        //         for(let i = 0; i < this.list_category.length; i++){
        //             for(let j = 0; j < this.selectListCategory.length; j++){
        //                 if(this.selectListCategory[j].id == this.list_category[i].id_category){
        //                     ret.push(this.list_category[i].id_category)
        //                 }
        //             }
        //         }
        //     }
        //     return ret
        // },
    },
    methods: {
        showModal() {
            this.isModalVisible = true;
        },
        closeModal() {
            this.isModalVisible = false;
        },
        get() {
            var data = [];
            var token = '';
            ArticleService.show(data, token)
            .then(response => {
                if (response.data.code == 200) {
                    this.data = response.data.data;
                    console.log(this.data)
                }else{
                    this.$toastr.error(response.data.message);
                }
            })
        },
        save() {
            this.$swal({
                title: "Store data?",
                    text: "Are you sure? You won't be able to revert this!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    confirmButtonText: "Yes, do it!",
                    closeOnConfirm: true
                    }).then((result) => {
                        if (result.isConfirmed) {
                            ArticleService.create(this.dataModal)
                            // .then(response => {
                            //     if (response.data.code == 200) {
                            //         this.$toastr.success(response.data.message);
                            //     }else{
                            //         this.$toastr.error(response.data.message);
                            //     }
                            //     this.get()
                            // })
                            // .catch(e => {
                            //     console.log(e)
                            // });
                        }
                    })
        },
        edit(id) {
            Object.assign(this.$data.dataModal, this.$options.data().dataModal)
            CategoryService.show()
            .then(response => {
                this.selectListCategory = response.data.data
            })
            .catch(e => {
                console.log(e);
            });
            this.title = 'Create Data'
            if (id != undefined) {
                var data = {id:id}
                ArticleService.show(data)
                .then(response => {
                    if (response.data.code == 200) {
                        this.dataModal = response.data.data[0]
                        console.log(this.dataModal)
                        this.title = 'Update Data'
                        this.modalShow = true
                    }else{
                        this.isModalVisible = false;
                        this.$toastr.error(response.data.message);
                    }
                })

            }else{
                this.title = 'Create Data'
                this.modalShow = true
            }
        },
        onChangeType(event) {
            if (event.target.value == 'Sub Category') {
                this.show = true
            }else{
                this.show = false
            }
        },
        delete_data(id) {
                this.$swal({
                    title: "Delete data?",
                    text: "Are you sure? You won't be able to revert this!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    confirmButtonText: "Yes, Delete it!",
                    closeOnConfirm: true
                    }).then((result) => {
                        if (result.isConfirmed) {
                            ArticleService.delete(id)
                            .then(response => {
                                if (response.data.code == 200) {
                                    this.$toastr.success(response.data.message);
                                }else{
                                    this.$toastr.error(response.data.message);
                                }
                                this.get()
                            })
                        }
                    })
        },
    },
    mounted () {
        this.get();
    }
  }
</script>
